# N-Body project - Checklist

### Task 1
- [x] Compute characteristic quantities/scales
- [x] Compare analytical model and particle density distribution
- [x] Compute forces through nbody simulation
- [x] vary softening length and compare results
- [x] compare with the analytical expectation from Newtons 2nd law
- [x] compute the relaxation time

### Task 2 (particle mesh)
- [ ] Choose reasonable units
- [~x] Implement force computation on mesh
- [x] Find optimal mesh size
- [x] Compare with direct nbody simulation
- [ ] Time integration for direct method AND mesh method


### Task 2 (tree code)
- [ ] Implement force computation with multipole expansion
    - [ ] Find optimal grouping criterion
- [ ] Compare with direct nbody simulation
- [ ] Time integration for direct method AND tree method








### Questions
- How to represent the time evolution of the system?
    - plot total energy vs time
    - plot particle positions?
- What is the parameter a of the Hernquist model?
- How to handle zero values for the k vector in the mesh method?